-- name: [CS] \\#ff6a00\\Marine the Raccoon
-- description: \\#ff6a00\\Marine the Raccoon\\#ffffff\\, now in \\#ff0000\\sm64coop-dx\\#ffffff\\!\n\n\\#ffffff\\Made by klasky, voices from \\#FFE97C\\A Hat in Time\\#ffffff\\ (Mustache Girl (voiced by Eileen Montgomery), I took inspiration from a Reddit comment), life icon by FireX, yawning sound and drowning sound from YouTube (\\#ff7777\\https://www.youtube.com/watch?v=0DGQzG6FOTU\\#ffffff\\ and \\#ff7777\\https://www.youtube.com/watch?v=Q9kd9g4MkGw\\#ffffff\\), model from \\#0094ff\\Sonic Rush Adventure\\#ffffff\\ by Dimps and Sonic Team.

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/wiki/API-Documentation

    Use this if you're curious on how anything here works >v<
	(This is an edited version of the Template File by Squishy)
]]

local TEXT_MOD_NAME = "Marine the Raccoon"

-- Stops mod from loading if Character Select isn't on
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_MODEL_CUSTOM_MODEL = smlua_model_util_get_id("marine_geo") -- Located in "actors"

local TEX_CUSTOM_LIFE_ICON = get_texture_info("marinelifeicon") -- Located in "textures"

-- All Located in "sound" Name them whatever you want. Remember to include the .ogg extension
local VOICETABLE_MARINE = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'GetStar.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'GetStar.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'Punch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Punch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Punch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Jump1.ogg', 'Jump2.ogg', 'Jump3.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'DoubleJump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'HOOYAH.ogg', 'HOOYAH.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'Damaged.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Silent.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'HOOYAH.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'Ow.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'Silent.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'Ugh.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'NOOO.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'HOOYAH.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'Push.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'GetStar.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'ThrowBowser.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'Damaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'Burned.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Silent.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Yawn.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Silent.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Silent.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Cough.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Silent.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Dying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Drown.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'ComeOn.ogg' -- Booted out of level
}

-- All Located in "actors"
local CAPTABLE_CHAR = {
    normal = smlua_model_util_get_id("marinenormal_geo"),
    wing = smlua_model_util_get_id("marinewing_geo"),
    metal = smlua_model_util_get_id("marinemetal_geo"),
}

local PALETTE_CHAR = {
    [PANTS]  = "F06808",
    [SHIRT]  = "F06808",
    [GLOVES] = "F8D878",
    [SHOES]  = "F86808",
    [HAIR]   = "F06808",
    [SKIN]   = "ffffff",
    [CAP]    = "ffffff",
	[EMBLEM] = "ffffff"
}

local CSloaded = false
local function on_character_select_load()
    CT_MARINE = _G.charSelect.character_add("Marine the Raccoon", {"Marine is an energetic", "and adventurous rascal from", "Southern Island, that", "somehow ended up in", "Mario's world. Hearing", "about Peach being", "trapped in the castle, ", "she joins Mario and his", "pals to collect the Power Stars! "}, "klasky", {r = 255, g = 106, b = 0}, E_MODEL_CUSTOM_MODEL, CT_MARINE, TEX_CUSTOM_LIFE_ICON)
    _G.charSelect.character_add_caps(E_MODEL_CUSTOM_MODEL, CAPTABLE_CHAR)
    _G.charSelect.character_add_voice(E_MODEL_CUSTOM_MODEL, VOICETABLE_MARINE)
    _G.charSelect.character_add_celebration_star(E_MODEL_CUSTOM_MODEL, E_MODEL_CUSTOM_STAR, TEX_CUSTOM_STAR_ICON)
    _G.charSelect.character_add_palette_preset(E_MODEL_CUSTOM_MODEL, PALETTE_CHAR)
    _G.charSelect.character_add_health_meter(CT_MARINE, HM_MARINE)

    CSloaded = true
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_MARINE then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_MARINE then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)